;**********************************************************************************
;pallina che cade su di un piano inclinato con infissi dei chiodini 2008/05/08

(defun c:pallinac ()					;funzione principale
(setvar "highlight" 0)
(setvar "cmdecho" 0)
(setvar "osmode" 0)
(setq g 0.0004)						;accelerazioni lungo y
(setq vis 0.001)						;attrito viscoso
(setq t 1.0)						;tempo
(setq rc 0.1)						;raggio chiodini
(setq rp 0.25)						;raggio pallina
(setq d (* 10 (+ rc rp)))
(setq point 0)

(command "_-layer" "n" "chiodini" "_c" 8 "chiodini" "_s" "chiodini" "")
(foreach q (pallinacchiodi) (command "_circle" q rc))	;disegna la griglia dei chiodini

(setq p (getpoint "\nPunto di partenza: "))
(command "_-layer" "n" "pallina" "_c" 1 "pallina" "_s" "pallina" "")
(command "_circle" p rp)
(setq x (car p))
(setq y (cadr p))
;(setq q (getpoint p "\nDirezione e velocit: "))
;(setvar "cecolor" "3")
;(command "_circle" q rp)
;(setq vx (/ (- (car q) (car p)) 10.0))
;(setq vy (/ (- (cadr q) (cadr p)) 10.0))
;(setq x 5.3)						;posizione iniziale della pallina
;(setq y 7.0)
(setq vx 0.0)						;velocita iniziale della pallina
(setq vy 0.0)
(while (>= y (* -1 (+ rc rp)))
 (setq q p)
 (pallinacposiz)
 (command "_move" "_l" "" q p)
 (pallinactest)
)
(prompt "\nHai fatto ")
(princ point)
(prompt " punti!")
(princ)
)

(defun pallinacchiodi ()				;griglia dei chiodini ;possibile parametrizzazione della griglia
(setq listac (list
(list 0.0 0.0)	(list 2.0 0.0)	(list 4.0 0.0)	(list 6.0 0.0)	(list 8.0 0.0)	(list 10.0 0.0)	(list 12.0 0.0)	(list 14.0 0.0)	(list 16.0 0.0)
(list 1.0 1.0)	(list 3.0 1.0)	(list 5.0 1.0)	(list 7.0 1.0)	(list 9.0 1.0)	(list 11.0 1.0)	(list 13.0 1.0)	(list 15.0 1.0)
(list 0.0 2.0)	(list 2.0 2.0)	(list 4.0 2.0)	(list 6.0 2.0)	(list 8.0 2.0)	(list 10.0 2.0)	(list 12.0 2.0)	(list 14.0 2.0)	(list 16.0 2.0)
(list 1.0 3.0)	(list 3.0 3.0)	(list 5.0 3.0)	(list 7.0 3.0)	(list 9.0 3.0)	(list 11.0 3.0)	(list 13.0 3.0)	(list 15.0 3.0)
(list 0.0 4.0)	(list 2.0 4.0)	(list 4.0 4.0)	(list 6.0 4.0)	(list 8.0 4.0)	(list 10.0 4.0)	(list 12.0 4.0)	(list 14.0 4.0)	(list 16.0 4.0)
(list 1.0 5.0)	(list 3.0 5.0)	(list 5.0 5.0)	(list 7.0 5.0)	(list 9.0 5.0)	(list 11.0 5.0)	(list 13.0 5.0)	(list 15.0 5.0)
(list 0.0 6.0)	(list 2.0 6.0)	(list 4.0 6.0)	(list 6.0 6.0)	(list 8.0 6.0)	(list 10.0 6.0)	(list 12.0 6.0)	(list 14.0 6.0)	(list 16.0 6.0)
(list 1.0 7.0)	(list 3.0 7.0)	(list 5.0 7.0)	(list 7.0 7.0)	(list 9.0 7.0)	(list 11.0 7.0)	(list 13.0 7.0)	(list 15.0 7.0)
(list 0.0 8.0)	(list 2.0 8.0)	(list 4.0 8.0)	(list 6.0 8.0)	(list 8.0 8.0)	(list 10.0 8.0)	(list 12.0 8.0)	(list 14.0 8.0)	(list 16.0 8.0)
(list 1.0 9.0)	(list 3.0 9.0)	(list 5.0 9.0)	(list 7.0 9.0)	(list 9.0 9.0)	(list 11.0 9.0)	(list 13.0 9.0)	(list 15.0 9.0)
)))

;(defun pallinacchiodi ()				;griglia dei chiodini ;possibile parametrizzazione della griglia
;(setq xmin 0.0)
;(setq xmax 10.0)
;(setq ymin 0.0)
;(setq ymax 10.0)
;(setq xi xmin)
;(setq yi ymin)
;(setq listac (list xi yi))
;(setq dx 1.0)
;(setq dy 1.0)
;(setq sdx (/ dx 2.0))
;(setq ndx (fix (/ (- xmax xmin) dx)))
;(setq ndy (fix (/ (- ymax ymin) dy)))
;(repeat ndy
; (repeat ndx
;  (setq xi (+ xi dx))
;  (setq listac (cons listac (list xi yi)))
; )
; (setq xi xmin)
; (setq yi (+ yi dy))
;)
;(princ listac)
;)

(defun pallinacposiz ()
(setq ax (* -1 vis vx))
(setq ay (+ (* -1 g) (* -1 vis vy)))
(setq vx (+ vx (* ax t)))
(setq vy (+ vy (* ay t)))
(setq sx (+ (* vx t) (* 0.5 ax t t)))
(setq sy (+ (* vy t) (* 0.5 ay t t)))
(if (< d (* 1.0 (+ rp rc)))
 (progn
  (setq sx (* 20.0 sx))
  (setq sy (* 20.0 sy))
 )
)
(setq x (+ x sx))
(setq y (+ y sy))
(setq p (list x y))
;(command "_circle" p rp)
;(command "_move" "_l" "" q p)
)

(defun pallinactest ()					;rivedere formule per rimbalzo
(setq n 0)
(setq l (length (pallinacchiodi)))
(repeat l
 (setq c (nth n (pallinacchiodi)))
 (setq d (distance c p))
 (if (< d (* 1.0 (+ rp rc)))
  (progn
   (setq point (+ point 10))
   (setq angpq (angle p q))
   (setq angcp (angle c p))
;   (setq angv (* -1 (atan (/ vy vx))))   
   (setq ang (- angcp (- angpq angcp)))
   (setq v (sqrt (+ (* 0.9 vx vx) (* 0.9 vy vy))))
   (setq vx (* 1.0 v (cos ang)))
   (setq vy (* 1.0 v (sin ang)))
  )
 )
 (setq n (+ n 1))
)
)

;**********************************************************************************
